//
//
//   
//
//      M.E.@2012,2013
//
//      
//
//
//
import java.applet.Applet;	// duh
import java.awt.image.*;	// bufferedimage
import java.awt.*;		// graphics stuff
import java.awt.AWTEvent;	// enableEvents
import java.awt.event.KeyEvent;	// Keys
import java.util.*;		// StringTokenizer


public class a extends Applet {

	// avoid different methods .. init and paint = only paint
	// Unfortunately the event (keyboard/mouse) will need an extra method

	boolean keys[] = new boolean[65536];

	public void init(){
// Check
	        enableEvents(AWTEvent.KEY_EVENT_MASK);
		setVisible(true);
		requestFocus();
		
		long t_;			// (sleep)Time
		final int sleeptime=60;

// GRID can be different for each level
int GRID=16;     
// Calculated TILESIZE depending on the grid?
int TILESIZE=24;                   
int fcc=0;
int fc=0;
int dc=0;
int af[][]=new int[2000][5];



		final int EXTRA_X=160;
		final int EXTRA_Y=60;


                //
                // Game States
                //
		final int PLAY=100;
        	final int RESTART=101;
	        final int DRAW=102;
	        final int NEXTLEVEL=103;
        	final int LEVELMENU=104;
	        final int EDITORMENU=105;
		final int EDITOR=106;
		final int MAKE=107;
		final int GRIDSELECT=108;
		final int LOAD=109;
		final int CUSTOMLEVELS=110;
		// Start action
		int action=LEVELMENU;
//		int action=NEXTLEVEL;

                     
int customlevels=0;
int customcount=0;

		boolean ok=true;                      

		// polygon objects
		String Objects="EJZGHJKSTJZEGGHHIIJJKKEABEFJKSTJZEGGHHIIJJKK";


		String slevels="A4C0B0AC1B0C0BD4C.";
		slevels+="B9CC4AB0CBCBCBC0B0CBCBCBC0B0CBCBCBC0B0C1B1U0B0CB3CB1CBC3BU0CBC2BUD9C.";
		// unique pallete for all the levels;

		String levels="";
//                                    A      B         C       D        E     F          G          H        I        J       K        L     M         N         O        P           Q        R       S      T          U          V        W        X        Y        Z       {
		final int[] palette={0,-1,-7825556,-4181692,-131076,-12772074,-9107920,-6290656,-4181692,-2585538,-601851,-663950,-9484483,-5937295,-2195053,-11710362,-16751732,-14592873,-12409114,-11366365,-5845709,-15310047,-11642586,0,0,0};
		//
                //	Data
		//
		int map[]=new int[(GRID*GRID)+4];
	        int tempmap[]=new int[(GRID*GRID)+4]; // keep a backup
	        int steps=0;




		final int NROFOBJECTS=100;
		final int POLLYPOINTS=27;
		final int SIZE=1;		// polly points * size pixels
		
		int[][][] PollyArray = new int[NROFOBJECTS][2][POLLYPOINTS];
		int[] tempXArray=new int[POLLYPOINTS];
		int[] tempYArray=new int[POLLYPOINTS];

		int[] points=new int[NROFOBJECTS];
		int level=0;
		final int maxslevels=5;


		int x=(GRID*3)+2;		// player position

		
		final BufferedImage screen = new BufferedImage(800, 600, BufferedImage.TYPE_INT_RGB);
		final Graphics g = screen.getGraphics();

		// omitting this saves a lot of bytes .. but it isn't that nice
		// 
                //g.setFont(new Font("Helvetica",Font.PLAIN,18));
                // But if we remove helvetica it saves another 4 bytes
		g.setFont(new Font("",Font.PLAIN,18));

		int j=0;
		int obj=0; //ojbect
		int c=0; // coordinates
		while(j < Objects.length()){
			points[obj]=(Objects.charAt(j)-64);
			j++;
//System.out.println("Points object: "+obj+" : "+points[obj]);
			int jj=j;//
			int op=0; // objectpoints
			while(j < jj+points[obj] && j < Objects.length()){	
				int coor=((Objects.charAt(j)-64)*SIZE);
//System.out.println("coor: "+coor);
				PollyArray[obj][op%2==0?0:1][c]=coor;
				if(op%2!=0)c++;
				op++;	
				jj++;
				j++;
			}
			obj++;
			j++;
		}

                // Game loop.
		while (true) {
			// Use when you don't have a run method
			t_=System.currentTimeMillis();




			// replace all occurrences p with map
			int p=0; int p2=0; int ip=0;
			// Make background where player stands
			if(action == DRAW){
				map[x]=1;
			}
			if(action == DRAW || action == EDITOR){
	
				if(keys[KeyEvent.VK_LEFT] && x%GRID > 1) {
	
					ip=-1;
					steps++;
				}
	
				if(keys[KeyEvent.VK_RIGHT] && x%GRID < GRID-2) {
					ip=+1;
					steps++;
				}

				if(keys[KeyEvent.VK_UP] && x > GRID*2) {
					ip=-GRID;
					steps++;
	
				}
	

				if(keys[KeyEvent.VK_DOWN] && x < (GRID*(GRID-2)) ) {
					ip=+GRID;	
					steps++;
				}
				x=x+ip;
				if(action == DRAW){
					// put player on board
					map[x]=0;		// 0 = player
				}
				
			} // action == draw or edtior == no menu	

			// fill background
			g.setColor(new Color(palette[1]));
			g.fillRect(0, 0, 800, 600);
                        
			switch(action){
				// Menu
				case LEVELMENU:
					g.setColor(new Color(palette[0]));
					for(int i=1; i<maxslevels+1; i++){
						g.drawString(""+(char)(i+64)+""+(i==maxslevels?" = CUSTOM":" = LEVEL "+(i)), 50, 50+(i*24));
					}

					// Get Key
					for(int i=65; i < 65+maxslevels; i++){
					
						if(keys[i]){
							if(i==65+maxslevels) action=EDITORMENU;
							else{
								level = i-65-1;
								action=NEXTLEVEL;
							}
						}
					}
					
	
					break;
				case NEXTLEVEL:
					// Go back to the first level
					if(level++ > maxslevels+customcount-1){level=1;}
//System.out.println("LEVEL : "+level);

					action=LOAD;
					break;
				case LOAD:
					steps=0;
//System.out.println("Loading level: "+level);
					// (re-)build level string					
					levels=slevels+customlevels;

					// Make Array
					
					int a=0;
					ok=false;
					boolean begin=true;
					int levelcounter=0;
					// grid counter ; the level data counter
					int gc=0;
					while(a < levels.length() && !ok){
						char ch=levels.charAt(a++);

						// begin of level .. what is the grid?
						// gc=gridcounter
						if(begin){
//							GRID=(5*(ch-64));
							map=new int[(GRID*GRID)+4];
							tempmap=new int[(GRID*GRID)+4];
							for(int mi=0; mi < GRID*GRID; mi++)map[mi]=1;

							begin=false;
							gc=0;
						}else{
							// Nr?
							if(ch < 65){
								// . = end of level
								if(ch==46){
									begin=true;
									if(levelcounter++==level-1){
//System.out.println("Ready loading level: "+level);
										ok=true;
									}
		
								}else{
									int nextc=levels.charAt(a++);
									// nr;
									for(int i=0; i<(ch-48)+2; i++){
										map[gc++]=nextc-65;
									}
								}
							}else{
								// put the character on the map
								if( (map[gc++]=ch-65)==0){x=gc-1;}
							}	
						} // if begin or in the data-area?
	
					}
					a=0; 
					ok=false;
					int cl=0;	// color level
					levelcounter=0;

					action=DRAW;


					break;


                                        // 
                                        //
                                        // End of NEXTLEVEL


				case RESTART:
                                        for(int jjj=0; jjj<(GRID*GRID)+1; jjj++){
                                              map[jjj]=tempmap[jjj];
					}
        
                                        
                                        action=DRAW;
                                        break;
			}   // Switch action
			// we do this for both editor and play-states
        
			// border
			for(int i=0; i < (GRID*GRID)+1; i++){
				if(i < GRID)map[i]=2;
				if(i % GRID == 0)map[i]=2;
				if(i % GRID == GRID-1)map[i]=2;
				if(i > (GRID*GRID)-GRID)map[i]=2;
			}


				
			// Calculate game area
			TILESIZE=320/GRID;


                        //
                        // DRAW
                        //
                        // Do we need to draw the board?
			if(action == DRAW){
//System.out.println("Grid: "+GRID);
                                // Draw each grid item
				for(int i=0; i < GRID*GRID; i++){
					int xx=EXTRA_X+((i%GRID)*TILESIZE);
                                        int yy=EXTRA_Y+((i>0?i/GRID:0)*TILESIZE);
//System.out.println("Map["+i+"]="+map[i]);

/*
					g.setColor(new Color(palette[map[i]]));
					if(map[i]==0)g.setColor(new Color(palette[0]));

if(map[i] < obj){
	for(int pp=0; pp < points[map[i]]; pp++){
		tempXArray[pp]=xx+PollyArray[map[i]][0][pp];
		tempYArray[pp]=yy+PollyArray[map[i]][1][pp];
	
//System.out.println(""+(new Date()).getTime()+"("+xx+","+yy+") Coordinate: "+tempXArray[pp]+" , "+tempYArray[pp]);
	}
g.fillRect(xx,yy,10,10);
g.fillPolygon (tempXArray, tempYArray, points[map[i]]);
//g.fillRect(xx,yy,10,10);
}  // if object

*/	
					g.setColor(new Color(palette[map[i]]));
					g.fillRect(xx,yy,TILESIZE,TILESIZE);
                	                
	                         } // for all grid items

				// steps + information
				//
				if(action == DRAW){
					g.setColor(new Color(palette[0]));
					g.drawString("STEPS :", EXTRA_X,EXTRA_Y);
					g.drawString(String.valueOf(steps), EXTRA_X+100,EXTRA_Y);

				}

			} // action == DRAW

			if(keys[KeyEvent.VK_RIGHT] && x%GRID < GRID-2){
				// animation
				for(int i=0; i < TILESIZE; i++){
					fc++;
					af[fc][0]=fcc;
					af[fc][1]=EXTRA_X+(TILESIZE*5)+i;
					af[fc][2]=TILESIZE*3;
					fcc++;
				}
			}

			if(action == DRAW){
				// animation
				if(fc > 0){	
					int dcc=dc;
					int ac=0;
					for(int i=0; i < fc; i++){
						if(af[i][0]==dc){
							// show animation frame
							int x_=af[i][1];
							int y_=af[i][2];
							g.fillRect(x_,y_,TILESIZE,TILESIZE);
							af[i][0]=-1;
							
				
						}
						if(af[i][0]==-1)ac++;
					}
					if(ac==fc)fc=0;
dc=dcc+1;
				}
				
			}

			//
			// ESCape
			//
			if(keys[27]){
				action=LEVELMENU;
			}
			//
			// Reset keys
			for(int i=0; i < 65536; i++)keys[i]=false;


			// sleep
			while((System.currentTimeMillis()-t_) < sleeptime){}
			// draw buffer to screen (avoid flicker)
			getGraphics().drawImage(screen,0,0,this);
		} // while true

	} // paint function

    protected void processKeyEvent(KeyEvent e)
    {
	        if (e.getID() != java.awt.Event.KEY_RELEASE)
		{
			keys[e.getKeyCode()] = true;
		}
    }


}
