//
// Show debug information
//
function setdebug(txt){
        document.getElementById("debug").value=document.getElementById("debug").value+"\r"+txt;
}

// Alter the object on the grid
// The undo stack will keep track of the changes...

function setGrid(o,i){
	// keep track in undo ..
//TODO: UNDO
	Grid[o]=i;
	if(i==playernr)playerpos=o;
}

// Change object into different image (refresh from Grid)
function setObject(o){
	iobject=Grid[o]-1;

	pxpos=(iobject%NR)*-TILESIZE;
	if(iobject > 0)pypos=Math.floor((iobject/NR))*-TILESIZE; else pypos=0;

	document.getElementById("object"+o).style.backgroundPosition=""+pxpos+"px "+pypos+"px";


}





// We want hedges along the border of the screen
function hedges(){
        setdebug("hedges");
	//
        // Hedges
        //
        for(i=1; i < gridsize*gridsize; i++){
		if(i%gridsize==0)Grid[i]=262;
		 if(i%gridsize==gridsize-1)Grid[i]=262;
         	if(Math.floor(i/gridsize)==0)Grid[i]=13;
                if(Math.floor(i/gridsize)==gridsize-1)Grid[i]=13;
        }

        // corners
        Grid[0]=273;
        Grid[gridsize-1]=272;
        Grid[(gridsize*gridsize)-gridsize]=261;
        Grid[(gridsize*gridsize)-1]=271;

}



var dataStructures = {
    stack : function() {                  
        var elements;
        
        this.push = function(element) {
            if (typeof(elements) === 'undefined') {
                elements = [];   
            }                            
		// adds the element to the bottom of the stack.
            elements.push(element);
        }
        this.pop = function() {
            if (typeof(elements) === 'undefined') {
                elements = [];   
            }                       
		// removes the last element of the stack     
            return elements.shift();
        }
        this.stackTop = function(element) {
            if (typeof(elements) === 'undefined') {
                elements = [];   
            }                            
            return elements[elements.length - 1];
        }
	// Gets the first element of the stack without removing it
	this.peek = function(){
		if(typeof(elements) === 'undefined'){
			return null;
		}else{
			if(elements.length > 0)
				return elements[0];
			else
				return null;
		}
	}
	this.isempty = function(){	
		if(typeof(elements) === 'undefined'){
			return true;
		}else{
			return elements.length < 1;
		}
	}
    }
}


function doaction(){
	// inspect the direction movement from the playerpos and calculate its action
	// 
	// dynamic function creation == obj<nr>hit<nr>
	// test if function exists -> execute function
	//
	move(playerpos, direction);
}


function left(){
	direction=-1;
	doaction();
}

function right(){
	direction=1;
	doaction();
}
function up(){
	direction=-gridsize;
	doaction();
}
function down(){
	direction=gridsize;
	doaction();
}

function move(pos,dir){
	playerpos=pos+dir;

}



function old_animation_move(pos,dir){
	if(!action.isempty() || !animation.isempty())return;
	busy=true;
	stepx=(dir==1?1:(dir==-1?-1:0));
	stepy=(dir==gridsize?1:(dir==-gridsize?-1:0));
	
	//
	// When we react to movement : player pushes rock (object.2)
	//

	// displaytime = global
	i=0; 
setdebug("FRAMES variable!! playerpos: "+playerpos+" pos: "+pos+" .. object on pos: "+Grid[pos]+".. Direction:"+dir+" stepx: "+stepx+" stepy:"+stepy);

frames=8;

	for(i=0; i < frames; i++){
		// First move the object to be pused
		var a=new Array();
		a[0]=displaytime+i;
		np=pos+dir;
		nx=np%gridsize;
		ny=np > 0 ? Math.floor(np/gridsize):0; 
//setdebug("next pos: "+np+"object of item: "+Grid[np]);

		a[1]=np;
		a[2]=(nx*TILE)+(i*stepx*(TILE/frames));
		a[3]=(ny*TILE)+(i*stepy*(TILE/frames));
//setdebug("set animation: "+a[0]+" object:"+a[1]+" x: "+a[2]+" y="+a[3]);
		animation.push(a);

		var a=new Array();
		a[0]=displaytime+i;
		// Now move player
		np=pos;
		nx=np%gridsize;
		ny=np > 0 ? Math.floor(np/gridsize):0; 
//setdebug("next pos: "+np+"object of item: "+Grid[np]);

		a[1]=np;
		a[2]=(nx*TILE)+(i*stepx*(TILE/frames));
		a[3]=(ny*TILE)+(i*stepy*(TILE/frames));
//setdebug("set animation: "+a[0]+" object:"+a[1]+" x: "+a[2]+" y="+a[3]);
		animation.push(a);
	
	} // for frames
	// i = now the last frame .. so we can now do the action ..
	var a=new Array();
	a[0]=displaytime+i;
	a[1]=pos;	//object position
	a[2]=1;		// BACKGROUND
	action.push(a);

	var a=new Array();
	a[0]=displaytime+i;
	a[1]=pos+dir;	//object position
	a[2]=Grid[pos];
//setdebug("set ACTION: "+a[0]+" object:"+a[1]+" item: "+a[2]);
	action.push(a);


	var a=new Array();
	a[0]=displaytime+i;
	a[1]=pos+dir+dir;	// object position
	a[2]=Grid[pos+dir];
//setdebug("set ACTION: "+a[0]+" object:"+a[1]+" item: "+a[2]);
	action.push(a);

	busy=false;
} // push/move


function GameLoop(){
	peektime=0; // check if we still have something to draw during this displaytime - in that case we don't increase displaytime
	if(!busy){
//
//
// RESET KEY S
//
//

//elapsed=(new Date().getTime())-framestart;
//if(elapsed < drawsleep*step)
//	slow=false;
//else    slow=true;

if(Keys[45]){
thelevel=document.getElementById('level').value;
if(thelevel > 0){
	setdebug("level load: "+thelevel);
document.location.href="http://martineijmans.nl/martineijmans.nl/4k/prof4k/network.php?cmd=getlevel&data=1."+thelevel;
}


}

if(Keys[119]){
document.location.href="http://martineijmans.nl/martineijmans.nl/4k/prof4k/network.php?cmd=getlevels";
}



// Delete = undo
if(Keys[46]){
	setdebug(" DELETE ");
	Keys[46]=false;
//	undo();
}
if(Keys[27]){
	setdebug(" ESCAPE ");
	Keys[27]=false;
}

// Movement
// WII left = 178
if(Keys[37] || Keys[178]){
	left();
Keys[37]=false;
Keys[178]=false;
}
	// WII 175
if(Keys[38] || Keys[175]){
	up();
Keys[38]=false;
Keys[175]=false;
}
// WII 177
if(Keys[39] || Keys[177]){
	right();
Keys[39]=false;
Keys[177]=false;
}
// WII 176
if(Keys[40] || Keys[176]){
	down();
Keys[40]=false;
Keys[176]=false;
}

if(Keys[32]){
	Grid[playerpos]=BACKGROUND;
}
// Check keys
for(a=1; a < 27; a++){
	if(Keys[65+a]){
		Grid[playerpos]=a+1;
		Keys[65+a]=false;
	}
}

if(Keys[65]){
	thelevel=document.getElementById('level').value;
if(thelevel > 0){
	// save
	out="";
	for(i=0; i < gridsize*gridsize; i++){
		if(Grid[i] > 0 && Grid[i]<30){
			out+=""+String.fromCharCode(64+Grid[i]);
		}else out+="A";
	}
setdebug("String thelevel=\""+out+"\";");
document.location.href="http://martineijmans.nl/martineijmans.nl/4k/prof4k/network.php?cmd=store&data="+thelevel+"."+out;

}
}
Keys[65]=false;
} // !busy

for(i=0; i < gridsize*gridsize; i++){
setObject(i);

} // for grids

		np=playerpos;
		nx=np%gridsize;
		ny=np > 0 ? Math.floor(np/gridsize):0; 
//setdebug("next pos: "+np+"object of item: "+Grid[np]);
		document.getElementById("player"+playernr).style.left=(nx*TILE)+"px";
		document.getElementById("player"+playernr).style.top=(ny*TILE)+"px";

	GameTimer=15;
	setTimeout(GameLoop, GameTimer);
} // funcrtion


//
//
//
// ==== GAMELOOP
//
function oldGameLoop(){
	peektime=0; // check if we still have something to draw during this displaytime - in that case we don't increase displaytime
	if(!busy){
//
//
// RESET KEY S
//
//

//elapsed=(new Date().getTime())-framestart;
//if(elapsed < drawsleep*step)
//	slow=false;
//else    slow=true;


// Delete = undo
if(Keys[46]){
	setdebug(" DELETE ");
	Keys[46]=false;
//	undo();
}
if(Keys[27]){
	setdebug(" ESCAPE ");
	Keys[27]=false;
}

// Movement
// WII left = 178
if(Keys[37] || Keys[178]){
	left();
Keys[37]=false;
Keys[178]=false;
}
	// WII 175
if(Keys[38] || Keys[175]){
	up();
Keys[38]=false;
Keys[175]=false;
}
// WII 177
if(Keys[39] || Keys[177]){
	right();
Keys[39]=false;
Keys[177]=false;
}
// WII 176
if(Keys[40] || Keys[176]){
	down();
Keys[40]=false;
Keys[176]=false;
}



		// Check the stack
		// Do the animations
		//
		// DisplayTime variable acts like a frame - based animation instead of time - based
		//
		if(!animation.isempty()){
			var a=animation.peek();
	
			if(a!=null && a[0]==displaytime){
//setdebug("ANIMATION : Displaytime: "+a[0]+" object:"+a[1]+" coords: "+a[2]+","+a[3]+" Grid[object]: "+Grid[a[1]]);
						
				theobject=a[1];
				if(Grid[theobject] == playernr){
					// use direction to get the players angle
					px=-64;
					py=-0;
					document.getElementById("player"+playernr).style.backgroundPosition=""+px+"px "+py+"px";

					document.getElementById("player"+playernr).style.left=a[2]+"px";
					document.getElementById("player"+playernr).style.top=a[3]+"px";
				}else{
					document.getElementById("object"+theobject).style.left=a[2]+"px";
					document.getElementById("object"+theobject).style.top=a[3]+"px";
					//document.getElementById("object"+theobject).style.backgroundPosition=""+px+"px "+py+"px";

/*
					// The animation is not on the player, so create a animation object with the information
					objecti=Grid[theobject];
//setdebug("ANIMATION =-- Non player .. theobject: "+theobject+" : "+objecti+" level: "+level);

					animationcounter++;
					object
					oi=document.createElement('div');
             				oi.id="animation"+animationcounter;
					oi.name="animation"+animationcounter;	

					x0=a[2];
					y0=a[3];

					oi.style.left=(extrax+x0)+'px';
					oi.style.top=(extray+y0)+'px';
               				oi.style.width=TILE+'px';
            				oi.style.height=TILE+'px';

					oi.style.background="url('images/images_1.gif') no-repeat";
					// Position on the spritesheet .. move the sheet so we see only the part we want

					ix=(-(objecti%NR)+1)*TILE; 
					iy=-(objecti>0?Math.floor(objecti/NR):0)*TILE;
					
					oi.style.backgroundPosition=""+ix+"px "+iy+"px";

					oi.style.position='absolute';
					oi.style.visibility='visible';
					document.body.appendChild(oi);
*/

	
				}

	
				a=animation.pop(); // get the next
				a=animation.peek(); // inspect the next
				if(a!=null) peektime=a[0];

			}
		}else{
/*			// animationstack is empty .. remove all the objects
			for(i=0; i < animationcounter; i++){
				if(document.getElementById("animation"+animationcounter) != "undefined"){
					document.body.removeChild(document.getElementById("animation"+animationcounter));
				}
			}
*/
			animationcounter=0;
		}
		// check if we need to do an action?
		// After animations we tend to make actions like switch objects between eachother.
		if(!action.isempty()){
			var c=action.peek();
			if(c!=null && c[0]==displaytime){
setdebug("===ACTION : Displaytime: "+c[0]+" object:"+c[1]+" item "+c[2]);	

				setGrid(c[1],c[2]);
				// Display
				setObject(c[1]);
				c=action.pop();// get the next
				c=action.peek(); // inspect the next
				if(c!=null) peektime=c[0];


			} // if actionobject
		} // if action
		if(peektime!=displaytime)	
			displaytime++;
	
		if(animation.isempty() && action.isempty())displaytime=0;
	} // if busy?
	GameTimer=15;
	setTimeout(GameLoop, GameTimer);
}
